de.caff.generics

## Class References

- java.lang.Object
- - de.caff.generics.References

-     public final class References
      extends java.lang.Object

  Helper for reference creation.
  Author:
    Rammi

- - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static <V> ReferenceCreator<java.lang.ref.SoftReference<V>,V>` | `getSoftReferenceCreator()` Get a soft reference creator for a given value.
    `static <V> ReferenceCreator<java.lang.ref.SoftReference<V>,V>` | `getSoftReferenceCreator(java.lang.ref.ReferenceQueue<? super V> queue)` Get a soft reference creator for a given value.
    `static <V> ReferenceCreator<java.lang.ref.WeakReference<V>,V>` | `getWeakReferenceCreator()` Get a weak reference creator for a given value.
    `static <V> ReferenceCreator<java.lang.ref.WeakReference<V>,V>` | `getWeakReferenceCreator(java.lang.ref.ReferenceQueue<? super V> queue)` Get a weak reference creator for a given value.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### getSoftReferenceCreator

          @NotNull
          public static <V> ReferenceCreator<java.lang.ref.SoftReference<V>,V> getSoftReferenceCreator()

      Get a soft reference creator for a given value. This creator creates references not belonging to a reference queue.
      Type Parameters:
        `V` - value type
      Returns:
        soft reference creator for given value type

    - #### getSoftReferenceCreator

          @NotNull
          public static <V> ReferenceCreator<java.lang.ref.SoftReference<V>,V> getSoftReferenceCreator(@NotNull
                                                                                                                java.lang.ref.ReferenceQueue<? super V> queue)

      Get a soft reference creator for a given value.
      Type Parameters:
        `V` - value type
      Parameters:
        `queue` - the queue with which the reference is to be registered
      Returns:
        soft reference creator for given value type

    - #### getWeakReferenceCreator

          @NotNull
          public static <V> ReferenceCreator<java.lang.ref.WeakReference<V>,V> getWeakReferenceCreator()

      Get a weak reference creator for a given value. This creator creates references not belonging to a reference queue.
      Type Parameters:
        `V` - value type
      Returns:
        soft reference creator for given value type

    - #### getWeakReferenceCreator

          @NotNull
          public static <V> ReferenceCreator<java.lang.ref.WeakReference<V>,V> getWeakReferenceCreator(@NotNull
                                                                                                                java.lang.ref.ReferenceQueue<? super V> queue)

      Get a weak reference creator for a given value.
      Type Parameters:
        `V` - value type
      Parameters:
        `queue` - the queue with which the reference is to be registered
      Returns:
        soft reference creator for given value type